/* grid search in 4D,  KSL,Pierre 2003
3 db fenygorbet eltol y iranyban es megkeresi a helyes periodust a szoras minimumanal, PDM
forditas: gcc grid.c -lm -o grid */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

main ()

{

int i=0,j=0,k=0,l=0,q=0,p=0,r=0,x=0,y=0;
int index=0,run=0,count=0; /* futoindexek */
int a=0,b=0,c=0,d=0;

double mag_a[1000],mag_b[1000],mag_c[1000]; /* eredeti magnik */

double times_a[1000],times_b[1000],times_c[1000]; /* idok */

double fullmag[4000],fulltimes[4000]; /* kiertekelendo magnik es idok */

double dmaga=0.01,dmagb=0.01,dmagc=0.01; /* eltolasok lepeskoze magniban */

double magshift_a=0,magshift_b=0,magshift_c=0; /* a helyes eltolasok */

double period, per_min=0.3, per_max=0.7, dperiod=0.001; /* perioduskereses parameterei, lepeskoz*/

double magrange_a_min=0, magrange_a_max=0.01; /* a magnieltolasok hatarai*/

double magrange_b_min=-1.1, magrange_b_max=-0.9;

double magrange_c_min=-1, magrange_c_max=-0.7;

double sigma, sigma_min=10e6, sigma_i[10]; /* minimalis szigma, egyedi szigma */ 

double magni_a,magni_b,magni_c; /* az aktualis eltolasok */

double phase[4000]; /* fazis */ 

double ph,ph_range=0.1; /* szigma kereses parameter, fazislepes*/

double mag_sum,mag_aver[20]; /* magniosszeg es az atlagmagni*/

double per_true;

FILE * maga;
FILE * magb;
FILE * magc;


if ((maga = fopen( "1503a1.dat" , "rt"))== NULL)
    {
    fprintf (stderr, "Unsuccesfull file opening! \n");
    exit (-1);
    } 
else; 

if ((magb = fopen( "1503b1.dat" , "rt"))== NULL)
    {
    fprintf (stderr, "Unsuccesfull file opening! \n");
    exit (-1);
    } 
else; 

if ((magc = fopen( "1503c.mod.dat" , "rt"))== NULL)
    {
    fprintf (stderr, "Unsuccesfull file opening! \n");
    exit (-1);
    } 
else; 

do
    { 
    fscanf (maga, "%lf %lf", &times_a[i], &mag_a[i]);   
    i++;
    }
while (!feof(maga));
fclose (maga);

do
    { 
    fscanf (magb, "%lf %lf", &times_b[j], &mag_b[j]);    
    j++;
    }
while (!feof(magb));
fclose (magb);

do
    { 
    fscanf (magc, "%lf %lf", &times_c[k], &mag_c[k]);    
    k++;
    }
while (!feof(magc));
fclose (magc);

/* teljes ido es magni tomb feltoltese */

for (index=0; index<i; index++){fulltimes[index]=times_a[index];fullmag[index]=mag_a[index];}
for (index=i, q=0; index<i+j; index++, q++){fulltimes[index]=times_b[q];fullmag[index]=mag_b[q];}
for (index=i+j, p=0; index<i+j+k; index++, p++){fulltimes[index]=times_c[p];fullmag[index]=mag_c[p];}

/* magnitudo eltolas */	


for (period=per_min; period<=per_max; period=period+dperiod)	
				{
				printf (" \n Period: %lf Sigma min: %lf", period, sigma_min);
					for (run=0; run<index; run++)
						{ 
						/* feltekeres*/
						phase[run]=((fulltimes[run])/period)-(floor(fulltimes[run]/period));
						}				
				


for (magni_a=magrange_a_min; magni_a<magrange_a_max; magni_a=magni_a+dmaga)
	{	
	
	
	for (magni_b=magrange_b_min; magni_b<magrange_b_max;magni_b=magni_b+dmagb)
		{
		
		
		for (magni_c=magrange_c_min; magni_c<magrange_c_max; magni_c=magni_c+dmagc)
			{
			
				
				
				 /* teljes magnitudo tomb inicializalas */
				for (index=0; index<i; index++){fullmag[index]=mag_a[index]+magni_a;}
				for (index=i, q=0; index<i+j; index++, q++){fullmag[index]=mag_b[q]+magni_b;}
				for (index=i+j, p=0; index<i+j+k; index++, p++){fullmag[index]=mag_c[p]+magni_c;}
			 
				/* kernel!!!!! Fazis 10 reszre tagolas + atlagmagnitudo szamitasa */	
				
				for (ph=0, x=0; ph<1; ph=ph+ph_range, x++)
							
					{
					mag_sum=0;
					count=0;
					for (run=0; run<index; run++)
						{
						if ((phase[run] >= ph) & (phase[run] < ph+ph_range))
							{
							mag_sum=mag_sum+fullmag[run];
							count++;
							mag_aver[x]=mag_sum/count;							
							}
						
						}
						
					}
								
				/* szoras szamitasa */
				
				for (ph=0, y=0; ph<1; ph=ph+ph_range, y++)							
					{
					for (run=0; run<index; run++)
						{
						if ((phase[run] > ph) & (phase[run] < ph+ph_range))
							{
							sigma_i[y]=sigma_i[y]+pow((mag_aver[y]-fullmag[run]),2);
							}
						}
					}
					
				for (y=0; y<10; y++){sigma=sigma+sigma_i[y];}
				
				if(sigma<sigma_min)
					{
					sigma_min=sigma;
					per_true=period;
					magshift_a=magni_a;
					magshift_b=magni_b;
					magshift_c=magni_c;
					}
					
				for (y=0; y<10; y++){sigma_i[y]=0;}
				sigma=0;	
					
				
			}
		}
	   }
	 
	}
	
printf (" \n Shift_a: %lf Shift_b: %lf Shift_c: %lf", magshift_a, magshift_b, magshift_c);
printf (" \n True period: %lf Sigma min: %lf \n ", per_true, sigma_min);	
		
} /* main vege*/
